module timing
  contains
  function get_time()
    implicit none
    integer(kind=8) :: cnt, cnt_rate, cnt_max
    real*8 get_time

    call system_clock(cnt, cnt_rate, cnt_max)
    get_time = cnt
    get_time = get_time/cnt_rate
  end function
end module

program test_rkmethod

  use RKMethod, only: dagrt_state_type, &
    timestep_initialize => initialize, &
    timestep_run => run, &
    timestep_print_profile => print_profile, &
    timestep_shutdown => shutdown

  use sim_types

  implicit none

  type(region_type), target :: region
  type(region_type), pointer :: region_ptr

  type(sim_grid_state_type), pointer, dimension(:) :: initial_condition

  type(dagrt_state_type), target :: dagrt_state
  type(dagrt_state_type), pointer :: dagrt_state_ptr

  real*8 t_fin
  integer ntrips, igrid, idof
  parameter (t_fin=1d0, ntrips=20)

  integer istep

  ! start code ----------------------------------------------------------------

  dagrt_state_ptr => dagrt_state
  region_ptr => region
 
  region%n_grids = 2

  allocate(region%n_grid_dofs(region%n_grids))
  allocate(initial_condition(region%n_grids))

  do igrid = 1, region%n_grids
    region%n_grid_dofs(igrid) = 2
    allocate(initial_condition(igrid)%conserved_var(region%n_grid_dofs(igrid)))

    do idof = 1, region%n_grid_dofs(igrid)
      initial_condition(igrid)%conserved_var(idof) = 1
    end do
  end do

  call timestep_initialize( &
    region=region_ptr, &
    dagrt_state=dagrt_state_ptr, &
    state_y=initial_condition, &
    dagrt_t=0d0, &
    dagrt_dt=t_fin/20)

  do istep = 1,ntrips
    call timestep_run(region=region_ptr, dagrt_state=dagrt_state_ptr)
  enddo

  call timestep_print_profile(dagrt_state=dagrt_state_ptr)
  call timestep_shutdown(region=region_ptr, dagrt_state=dagrt_state_ptr)

end program

program test_rkmethod
  use RKMethod, only: dagrt_state_type, &
    timestep_initialize => initialize, &
    timestep_run => run, &
    timestep_shutdown => shutdown

  implicit none

  type(dagrt_state_type), target :: state
  type(dagrt_state_type), pointer :: state_ptr

  real*8, dimension(2) :: initial_condition, true_sol
  integer, dimension(2) :: ntrips

  integer run_count
  real*8 t_fin
  parameter (run_count=2, t_fin=1d0)

  real*8, dimension(run_count):: dt_values, errors

  real*8 est_order, min_order

  integer stderr
  parameter(stderr=0)

  integer istep, irun

  ! start code ----------------------------------------------------------------

  state_ptr => state

  initial_condition(1) = 2
  initial_condition(2) = 2.3

  ntrips(1) = 20
  ntrips(2) = 50

  do irun = 1,run_count
    dt_values(irun) = t_fin/ntrips(irun)

    call timestep_initialize( &
      dagrt_state=state_ptr, &
      state_y=initial_condition, &
      dagrt_t=0d0, &
      dagrt_dt=dt_values(irun))

    do istep = 1,ntrips(irun)
      call timestep_run(dagrt_state=state_ptr)
      if (associated(state%ret_state_y)) then
        write(*,*) state%ret_state_y
      endif
    enddo

    true_sol = initial_condition * exp(-2*state%ret_time_y)
    errors(irun) = sqrt(sum((true_sol-state%ret_state_y)**2))

    write(*,*) errors

    call timestep_shutdown(dagrt_state=state_ptr)
    write(*,*) 'done'
  enddo

  min_order = MIN_ORDER
  est_order = log(errors(2)/errors(1))/log(dt_values(2)/dt_values(1))

  write(*,*) 'estimated order:', est_order
  if (est_order < min_order) then
    write(stderr,*) 'ERROR: achieved order too low:', est_order, ' < ', &
        min_order
  endif

end program

program test_rkmethod
  use RKMethod, only: dagrt_state_type, &
    timestep_initialize => initialize, &
    timestep_run => run, &
    timestep_shutdown => shutdown

  implicit none

  type(dagrt_state_type), target :: state
  type(dagrt_state_type), pointer :: state_ptr

  real*8, dimension(2) :: initial_condition
  real*8, dimension(100) :: step_sizes

  real*8 t_fin, dt_value, small_step_frac, big_step_frac, old_time
  parameter (t_fin=1d0)

  integer stderr
  parameter(stderr=0)

  integer istep, nruns, num_big_steps, num_small_steps
  parameter (nruns = 100)

  ! start code ----------------------------------------------------------------

  state_ptr => state

  initial_condition(1) = 2
  initial_condition(2) = 0

  dt_value = 1e-5
  old_time = 0d0
  num_big_steps = 0
  num_small_steps = 0

  call timestep_initialize( &
      dagrt_state=state_ptr, &
      state_y=initial_condition, &
      dagrt_t=0d0, &
      dagrt_dt=dt_value)

  do istep = 1, nruns

    call timestep_run(dagrt_state=state_ptr)

    step_sizes(istep) = state%ret_time_y - old_time
    old_time = state%ret_time_y

    if (step_sizes(istep)<0.01d0) then
      num_small_steps = num_small_steps + 1
    elseif (step_sizes(istep)>0.03d0) then
      num_big_steps = num_big_steps + 1
    endif

  enddo

  call timestep_shutdown(dagrt_state=state_ptr)
  write(*,*) 'done'

  big_step_frac = num_big_steps/real(nruns)
  small_step_frac = num_small_steps/real(nruns)

  if (big_step_frac>=0.16d0 .and. small_step_frac<=0.35d0) then
    write(*,*), "Test passes: big_step_frac = ", big_step_frac
    write(*,*), "Test passes: small_step_frac = ", small_step_frac
  else
    write(stderr,*), "Test fails: big_step_frac = ", big_step_frac
    write(stderr,*), "Test fails: small_step_frac = ", small_step_frac
  endif

end program

program test_rkmethod
  use RKMethod, only: dagrt_state_type, &
    timestep_initialize => initialize, &
    timestep_run => run, &
    timestep_shutdown => shutdown

  implicit none

  type(dagrt_state_type), target :: state
  type(dagrt_state_type), pointer :: state_ptr

  real*8, dimension(2) :: initial_condition, true_sol

  real*8 t_fin
  integer ntrips
  parameter (t_fin=1d0, ntrips=100)

  real*8 :: dt_value, error, atol

  integer stderr
  parameter(stderr=0)

  integer istep

  ! start code ----------------------------------------------------------------

  state_ptr => state

  initial_condition(1) = 2
  initial_condition(2) = 2.3

  dt_value = 1e-5
  atol = 1e-6

  call timestep_initialize( &
    dagrt_state=state_ptr, &
    state_y=initial_condition, &
    dagrt_t=0d0, &
    dagrt_dt=dt_value)

  do istep = 1, ntrips
    call timestep_run(dagrt_state=state_ptr)
  enddo

  true_sol = initial_condition * exp(-2*state%ret_time_y)
  error = sqrt(sum((true_sol-state%ret_state_y)**2))

  call timestep_shutdown(dagrt_state=state_ptr)
  write(*,*) 'done'

  if (error>atol) then
    write(stderr,*) 'ERROR: Max error exceeds tolerance:', error, ' < ', &
        atol
  endif

end program

module sim_types

    type region_type
        integer n_grids
        integer, pointer, dimension(:) :: n_grid_dofs
    end type

    type sim_grid_state_type
        real (kind=8), pointer, dimension(:) :: conserved_var
    end type
end module

program test_mrabmethod_squarewave
  use MRAB, only: dagrt_state_type, &
    timestep_initialize => initialize, &
    timestep_run => run, &
    timestep_shutdown => shutdown

  implicit none

  type(dagrt_state_type), target :: state
  type(dagrt_state_type), pointer :: state_ptr

  real*8, dimension(2) :: initial_condition 
  real*8, dimension(1) :: true_sol_fast, true_sol_slow
  integer, dimension(2) :: ntrips

  integer run_count, k
  real*8 t_fin
  parameter (run_count=2, t_fin=11d0)

  real*8, dimension(run_count):: dt_values, error_slow, error_fast

  real*8 min_order, est_order_fast, est_order_slow

  integer stderr
  parameter(stderr=0)

  integer irun

  ! start code ----------------------------------------------------------------

  state_ptr => state

  initial_condition(1) = (exp(0d0))*cos(0d0) ! fast
  initial_condition(2) = (exp(0d0))*sin(0d0) ! slow

  ntrips(1) = NUM_TRIPS_ONE
  ntrips(2) = NUM_TRIPS_TWO

  do irun = 1,run_count
    dt_values(irun) = t_fin/ntrips(irun)

    call timestep_initialize( &
      dagrt_state=state_ptr, &
      state_slow=initial_condition(2:2), &
      state_fast=initial_condition(1:1), &
      dagrt_t=0d0, &
      dagrt_dt=dt_values(irun))

    k = 0

    do
      if (k == 1) then
        state%dagrt_dt = dt_values(irun)/4
        k = 0
      else
        state%dagrt_dt = dt_values(irun)
        k = 1
      endif
      call timestep_run(dagrt_state=state_ptr)
      if (state%ret_time_fast.ge.t_fin) then
        exit
      endif
    end do 

    true_sol_fast = (exp(state%ret_time_fast))*cos(state%ret_time_fast)
    true_sol_slow = (exp(state%ret_time_slow))*sin(state%ret_time_slow)

    error_slow(irun) = sqrt(sum((true_sol_slow-state%ret_state_slow)**2))
    error_fast(irun) = sqrt(sum((true_sol_fast-state%ret_state_fast)**2))

    call timestep_shutdown(dagrt_state=state_ptr)
    write(*,*) 'done', dt_values(irun), error_slow(irun), error_fast(irun)
  enddo

  min_order = MIN_ORDER
  est_order_slow = log(error_slow(2)/error_slow(1))/log(dt_values(2)/dt_values(1))
  est_order_fast = log(error_fast(2)/error_fast(1))/log(dt_values(2)/dt_values(1))

  write(*,*) 'estimated order slow:', est_order_slow
  if (est_order_slow < min_order) then
    write(stderr,*) 'ERROR: achieved order too low:', est_order_slow, ' < ', &
        min_order
  endif

  write(*,*) 'estimated order fast:', est_order_fast
  if (est_order_fast < min_order) then
    write(stderr,*) 'ERROR: achieved order too low:', est_order_fast, ' < ', &
        min_order
  endif

end program
